// $Id: LOCA_TimeDependent_AbstractGroup.C,v 1.2 2005/02/01 19:33:41 mnphenow Exp $ 
// $Source: /space/CVS/Trilinos/packages/nox/src-loca/src/LOCA_TimeDependent_AbstractGroup.C,v $ 

//@HEADER
// ************************************************************************
// 
//                  LOCA Continuation Algorithm Package
//                 Copyright (2005) Sandia Corporation
// 
// Under terms of Contract DE-AC04-94AL85000, there is a non-exclusive
// license for use of this work by or on behalf of the U.S. Government.
// 
// This library is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
//  
// This library is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//                                                                                 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA                                                                                
// Questions? Contact Tammy Kolda (tgkolda@sandia.gov) or Roger Pawlowski
// (rppawlo@sandia.gov), Sandia National Laboratories.
// 
// ************************************************************************
//@HEADER

#include "LOCA_TimeDependent_AbstractGroup.H"

NOX::Abstract::Group::ReturnType
LOCA::TimeDependent::AbstractGroup::computeMassMatrix()
{
  return NOX::Abstract::Group::Ok;
}

bool
LOCA::TimeDependent::AbstractGroup::isMassMatrix() const
{
  return true;
}

NOX::Abstract::Group::ReturnType
LOCA::TimeDependent::AbstractGroup::applyMassMatrix(
					   const NOX::Abstract::Vector& input,
					   NOX::Abstract::Vector& result) const
{
  result = input;
  return NOX::Abstract::Group::Ok;
}

NOX::Abstract::Group::ReturnType
LOCA::TimeDependent::AbstractGroup::applyShiftedMatrix(
					  const NOX::Abstract::Vector& input,
					  NOX::Abstract::Vector& result,
					  double shift) const
{
  // Compute J*input
  NOX::Abstract::Group::ReturnType res = applyJacobian(input, result);

  // Compute J*input + shift*input
  result.update(shift, input, 1.0);

  return res;
}

