// $Id: LOCA_TurningPoint_MooreSpence_FiniteDifferenceGroup.C,v 1.1.2.1 2005/08/03 23:59:43 etphipp Exp $
// $Source: /space/CVS/Trilinos/packages/nox/src-loca/src/LOCA_TurningPoint_MooreSpence_FiniteDifferenceGroup.C,v $

//@HEADER
// ************************************************************************
// 
//                  LOCA Continuation Algorithm Package
//                 Copyright (2005) Sandia Corporation
// 
// Under terms of Contract DE-AC04-94AL85000, there is a non-exclusive
// license for use of this work by or on behalf of the U.S. Government.
// 
// This library is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
//  
// This library is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//                                                                                 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA                                                                                
// Questions? Contact Tammy Kolda (tgkolda@sandia.gov) or Roger Pawlowski
// (rppawlo@sandia.gov), Sandia National Laboratories.
// 
// ************************************************************************
//@HEADER

#include "LOCA_TurningPoint_MooreSpence_FiniteDifferenceGroup.H"

LOCA::TurningPoint::MooreSpence::FiniteDifferenceGroup::FiniteDifferenceGroup(
						     const LOCA::DerivUtils& d)
  : LOCA::MultiContinuation::FiniteDifferenceGroup(d)
{
}

LOCA::TurningPoint::MooreSpence::FiniteDifferenceGroup::FiniteDifferenceGroup(
         const LOCA::TurningPoint::MooreSpence::FiniteDifferenceGroup& source, 
	 NOX::CopyType type)
  : LOCA::MultiContinuation::FiniteDifferenceGroup(source, type)
{
}


LOCA::TurningPoint::MooreSpence::FiniteDifferenceGroup::~FiniteDifferenceGroup() 
{
}

LOCA::TurningPoint::MooreSpence::FiniteDifferenceGroup&
LOCA::TurningPoint::MooreSpence::FiniteDifferenceGroup::operator=(
	 const LOCA::TurningPoint::MooreSpence::FiniteDifferenceGroup& source)
{
  LOCA::MultiContinuation::FiniteDifferenceGroup::operator=(source);

  return *this;
}

NOX::Abstract::Group::ReturnType
LOCA::TurningPoint::MooreSpence::FiniteDifferenceGroup::computeDJnDpMulti(
				      const vector<int>& paramIDs, 
				      const NOX::Abstract::Vector& nullVector,
				      NOX::Abstract::MultiVector& result,
				      bool isValid)
{
  return LOCA::MultiContinuation::FiniteDifferenceGroup::derivPtr->
    computeDJnDp(*this, paramIDs, nullVector, result, isValid);
}

NOX::Abstract::Group::ReturnType
LOCA::TurningPoint::MooreSpence::FiniteDifferenceGroup::computeDJnDxaMulti(
			       const NOX::Abstract::Vector& nullVector,
			       const NOX::Abstract::MultiVector& aVector,
			       NOX::Abstract::MultiVector& result)
{
  return LOCA::MultiContinuation::FiniteDifferenceGroup::derivPtr->
    computeDJnDxa(*this, nullVector, aVector, result);
}

NOX::Abstract::Group::ReturnType
LOCA::TurningPoint::MooreSpence::FiniteDifferenceGroup::computeDJnDxaMulti(
			       const NOX::Abstract::Vector& nullVector,
			       const NOX::Abstract::Vector& JnVector,
			       const NOX::Abstract::MultiVector& aVector,
			       NOX::Abstract::MultiVector& result)
{
  return LOCA::MultiContinuation::FiniteDifferenceGroup::derivPtr->
    computeDJnDxa(*this, nullVector, aVector, JnVector, result);
}
