// $Id: NOX_LineSearch_Utils_Printing.C,v 1.3 2003/11/25 16:30:10 tgkolda Exp $ 
// $Source: /space/CVS/Trilinos/packages/nox/src/NOX_LineSearch_Utils_Printing.C,v $ 

//@HEADER
// ************************************************************************
// 
//            NOX: An Object-Oriented Nonlinear Solver Package
//                 Copyright (2002) Sandia Corporation
// 
// Under terms of Contract DE-AC04-94AL85000, there is a non-exclusive
// license for use of this work by or on behalf of the U.S. Government.
// 
// This library is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
//  
// This library is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//                                                                                 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA                                                                                
// Questions? Contact Tammy Kolda (tgkolda@sandia.gov) or Roger Pawlowski
// (rppawlo@sandia.gov), Sandia National Laboratories.
// 
// ************************************************************************
//@HEADER

#include "NOX_LineSearch_Utils_Printing.H"
#include "NOX_Utils.H"
#include "NOX_Common.H"

NOX::LineSearch::Utils::Printing::Printing(const NOX::Utils& u) :
  NOX::Utils(u)
{

}

NOX::LineSearch::Utils::Printing::~Printing()
{

}

void NOX::LineSearch::Utils::Printing::printStep(int n, double step, double oldf, double newf, const string s, bool unscaleF) const
{
  if (isPrintProcessAndType(NOX::Utils::InnerIteration)) 
  {
    cout << setw(3) << n << ":";
    cout << NOX::Utils::fill(1,' ') << "step = " << sciformat(step);
    if (unscaleF == true) {
      cout << NOX::Utils::fill(1,' ') << "oldf = " << sciformat(sqrt(2. * oldf));
      cout << NOX::Utils::fill(1,' ') << "newf = " << sciformat(sqrt(2. * newf));
    }
    else {
      cout << NOX::Utils::fill(1,' ') << "oldf = " << sciformat(oldf);
      cout << NOX::Utils::fill(1,' ') << "newf = " << sciformat(newf);
    }
    if (!s.empty()) 
    {
      cout << " " << s << "\n";
      cout << NOX::Utils::fill(72);
    }
    cout << endl;
  }
}
